angular.module('ngApp').controller('searchController', function($scope, $http, localStorage)
{
	$scope.loading = $scope.wloading = $scope.WMoreItems = false;
	$scope.searchText = '';
	$scope.results = [];
	$scope.noMoreItemsAvailable = true;
	$scope.notFound = false;
	var wordpress_page = 0;
	var start = 0;
	$scope.search = function(){
		if(isOnline() && $scope.searchText != '' && $scope.onlineMode)
		{
			$scope.onlineSearch($scope.searchText);
		}
		else
		{
			offlineSearch($scope.searchText)
		}
	}

	$scope.onlineSearch = function() {
		$scope.notFound = false;
		$scope.loading = true;
		$scope.results = [];

		$http({
			method: 'GET',
			noLoading: true,
			url: url + '/api/v1/widget/route/search/getSearch/' + $scope.sl + '?q=' + $scope.searchText + '&addressVersion=2'
		})
		.success(function(data) {
			for (var i = data.length - 1; i >= 0; i--) {
				$scope.results.push(data[i]);
			}
			if(data.length == 20){
				$scope.noMoreItemsAvailable = false;
			}
			if(data.length == 0){
				$scope.notFound = true;
			}
			$scope.loading = false;
			start = data.length;
		})
		.error(function() {
			$scope.loading = false;
			checkYourInternet();
		});

		if (has_wordpress) {
			wordpress_page = 0;
			searchInWordpress();
		}
	}

	function searchInWordpress() {
		wordpress_page++;
		for (var i = wordpress_search_urls.length - 1; i >= 0; i--) {
			$scope.wloading = true;
			$http({
					method: 'JSONP',
					noLoading: true,
					url: wordpress_search_urls[i] + '/wp-json/wp/v2/posts',
					params: {
						_jsonp: 'JSON_CALLBACK',
						search: $scope.searchText,
						page: wordpress_page,
						per_page: 10
					}
				})
				.success(function (data, status, y, config) {
					config.url = config.url.substr(0, config.url.indexOf("/wp-json"));
					var slug_index = wordpress_search_urls.indexOf(config.url);
					for (var ii = 0; ii < data.length; ii++) {
						$scope.results.push({
							title: data[ii].title.rendered,
							thump: '',
							link: wordpress_slug[slug_index] + data[ii].id
						});
						getImageFromWordpress($scope.results.length - 1, data[ii].featured_media, config.url);
					}
					$scope.wloading = false;
					$scope.WMoreItems = (data.length == 10);
					$scope.WiSLoading = false;
				})
				.error(function () {
					$scope.wloading = false;
				});
		}
	}

	function getImageFromWordpress(index, media_id, wordpress_url) {
		$http({
			method: 'JSONP',
			noLoading: true,
			url: wordpress_url + '/wp-json/wp/v2/media/' + media_id + '?_jsonp=JSON_CALLBACK'
		})
			.success(function (data) {
				$scope.results[index].thump = data.guid.rendered;
			});
	}

	$scope.loadMore = function() {
		if(!$scope.noMoreItemsAvailable){
			$scope.noMoreItemsAvailable = true;
			if(isOnline() && $scope.onlineMode){
				$scope.infiniteScrollLoading = true;
				$http({method: 'GET', noLoading : true, url: url + '/api/v1/widget/route/search/getSearch/' + $scope.sl + '/' +start + '?q=' + $scope.searchText })
				.success(function(data) {
					if (data.length == 0 || data.found == 0)
					{
						$scope.noMoreItemsAvailable = true;
					}
					else
					{
						for (var i = 0 ; i < data.length ; i++)
						{
							$scope.results.push(data[i]);
						}
					}
					if(data.length < 20){
						$scope.noMoreItemsAvailable = true;
					}else{
						$scope.noMoreItemsAvailable = false;
					}
					$scope.infiniteScrollLoading = false;

					start += data.length;
				})
				.error(function() {
					$scope.infiniteScrollLoading = false;
				});
			}
		}

		if (has_wordpress && $scope.WMoreItems){
			$scope.WiSLoading = true;
			$scope.WMoreItems = false;
			searchInWordpress();
		}
	};
});

function offlineSearch(searchedText) {
	search_complete = false;
	is_found = false;
	$("#notfound").hide();
	$("#results_list").html("");
	if(searchedText == "") return;

	$("#search_icon i").removeClass("ion-ios-search-strong").addClass("ion-load-d");

	check_loader = setInterval(function()
	{
		if(search_complete)
		{
			search_complete = false;
			if(is_found)
			{
				$("#results_list").show();
			}
			else
			{
				$("#notfound").show();
			}
		   $("#search_icon i").removeClass("ion-load-d").addClass("ion-ios-search-strong");
		   clearInterval(check_loader);
		}
	}, 1000);

	for(var i in searchArray)
	{
		searchIn(searchArray[i], searchedText);
	}
	search_complete = true;
}

function searchIn(page, key)
{

	if(page.title.indexOf(key) > -1)
	{
		$("#results_list").html($("#results_list").html()+'<a href="#/nav/puzzleysearch/'+page.slug+'/'+ key +'" class="item item-icon-left item-contact"><p>'+page.title+'</p></a>');
		is_found = true;
	}
	else
	{
		jQuery.ajaxSetup({async:false});
		r = Math.round(Math.random() * 10000);
		$.get(page.link,{subins:r},function(data)
		{
			data = $("<div />").html(data).text();
			if(data.indexOf(key) > -1)
			{
				$("#results_list").html($("#results_list").html()+'<a href="#/nav/puzzleysearch/'+page.slug+'/'+ key +'" class="item item-icon-left item-contact"><p>'+page.title+'</p></a>');
				is_found = true;
			}
		});
	}
}

function doHighlight(bodyText, searchTerm){var newText = ""; var i = -1;while (bodyText.length > 0){i = bodyText.indexOf(searchTerm, i+1);if (i < 0) {newText += bodyText;bodyText = "";} else{if (bodyText.lastIndexOf(">", i) >= bodyText.lastIndexOf("<", i)) {if (bodyText.lastIndexOf("/script>", i) >= bodyText.lastIndexOf("<script", i)) {newText += bodyText.substring(0, i) + "<search>" + bodyText.substr(i, searchTerm.length) + "</search>";bodyText = bodyText.substr(i + searchTerm.length);bodyText = bodyText.toLowerCase();i = -1;}}}}return newText;}
